diff --git a/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
similarity index 88%
rename from src/main/java/net/minecraft/client/net/handler/NetPingHandler.java
rename to src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 810b0601d..218fccdc7 100644
--- a/src/main/java/net/minecraft/client/net/handler/NetPingHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -4,16 +4,16 @@ import net.minecraft.client.gui.GuiSelectServer;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.net.packet.DisconnectPacket;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet255KickDisconnect;
 
 import java.io.IOException;
 import java.net.InetAddress;
 import java.net.Socket;
 
-public class NetPingHandler
-    extends NetHandler
+public class PingPacketHandler
+    extends PacketHandler
 {
     private boolean disconnected = false;
     private final GuiSelectServer gui;
@@ -21,7 +21,7 @@ public class NetPingHandler
     private final ServerData server;
     public static long startTime = 0;
 
-    public NetPingHandler(GuiSelectServer gui, ServerData server)
+    public PingPacketHandler(GuiSelectServer gui, ServerData server)
         throws IOException {
         this.gui = gui;
         this.server = server;
@@ -52,7 +52,7 @@ public class NetPingHandler
     }
 
     @Override
-    public void handleKickDisconnect(Packet255KickDisconnect packet) {
+    public void handleKickDisconnect(DisconnectPacket packet) {
         if (packet.reason.startsWith("§1"))
         {
             String[] serverInfo = packet.reason.split("\0");
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
index 75b59e083..8a46b17cb 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.net.thread;
 
-import net.minecraft.client.render.DownloadedTexture;
+import net.minecraft.client.render.texture.DownloadedTexture;
 import net.minecraft.client.render.ImageParser;
 
 import java.awt.image.BufferedImage;
@@ -18,10 +18,10 @@ public class ThreadDownloadImage extends Thread {
 	public final ImageParser imageParser;
 	public final DownloadedTexture texture;
 
-	public ThreadDownloadImage(DownloadedTexture texture, String url, ImageParser imageBuffer) {
+	public ThreadDownloadImage(DownloadedTexture texture, String url, ImageParser imageParser) {
 		this.texture = texture;
 		this.url = url;
-		this.imageParser = imageBuffer;
+		this.imageParser = imageParser;
 		setName("DownloadImage " + counter++);
 	}
 
@@ -46,7 +46,7 @@ public class ThreadDownloadImage extends Thread {
 				texture.image = imageParser.parseImage(image);
 			else
 				texture.image = image;
-			
+
 			inputStream.close();
 		} catch (Exception exception) {
 			exception.printStackTrace();
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index 4e7b5fe75..ec1702841 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.net.thread;
 
 import net.minecraft.client.gui.GuiSelectServer;
-import net.minecraft.client.net.handler.NetPingHandler;
+import net.minecraft.client.net.handler.PingPacketHandler;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
-import net.minecraft.core.net.handler.NetHandler;
-import net.minecraft.core.net.packet.Packet254PingHandshake;
+import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.net.packet.PingHandshakePacket;
 
 public class ThreadPingServer
     extends Thread {
@@ -14,7 +14,7 @@ public class ThreadPingServer
     private final GuiSelectServer gui;
     private final ServerData server;
     private boolean done = false;
-    private NetPingHandler netHandler = null;
+    private PingPacketHandler netHandler = null;
 
     public ThreadPingServer(GuiSelectServer gui, ServerData server) {
         this.gui = gui;
@@ -35,7 +35,7 @@ public class ThreadPingServer
         if (netHandler != null && isDone()) netHandler.processReadPackets();
     }
 
-    public NetHandler getNetHandler() {
+    public PacketHandler getNetHandler() {
         return netHandler;
     }
 
@@ -46,8 +46,8 @@ public class ThreadPingServer
         int port = address.getPort();
 
         try {
-            netHandler = new NetPingHandler(gui, server);
-            netHandler.addToSendQueue(new Packet254PingHandshake(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
+            netHandler = new PingPacketHandler(gui, server);
+            netHandler.addToSendQueue(new PingHandshakePacket(0x01, 0xFA, "BTAPingHost", Global.MP_PROTOCOL_VERSION, hostName, port));
         } catch (Exception ignored) {
         } finally {
             done = true;
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 98459f623..49be04e35 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -12,8 +12,6 @@ import java.util.List;
 
 import org.lwjgl.opengl.Display;
 
-import com.b100.utils.ReflectUtils;
-
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.hud.HudComponents;
@@ -83,6 +81,7 @@ public class GameSettings {
 	public BooleanOption disableShaders = new BooleanOption(this, "disableShaders", false);
 	public StringOption shaderOverride = new StringOption(this, "shaderOverride", "");
 	public BooleanOption autoHit = new BooleanOption(this, "autoHit", true);
+	public BooleanOption easyBridge = new BooleanOption(this, "easyBridge", true);
 	public BooleanOption foodHealthRegenOverlay = new BooleanOption(this, "foodHealthRegenOverlay", true);
 	public BooleanOption fpsInOverlay = new BooleanOption(this, "fpsInOverlay", false);
 	public BooleanOption versionInOverlay = new BooleanOption(this, "versionInOverlay", false);
@@ -236,14 +235,14 @@ public class GameSettings {
 	public KeyBinding keyShowShortcuts = new KeyBinding("key.debug.shortcuts").setDefault(InputDevice.keyboard, KEY_Q);
 	public KeyBinding keyToggleTextureAtlas = new KeyBinding("key.debug.textureAtlas");
 
-	public KeyBinding[] keys = ReflectUtils.getAllObjects(GameSettings.class, KeyBinding.class, this);
-
-	public Option<?>[] getAllOptions(){
-		return ReflectUtils.getAllObjects(GameSettings.class, Option.class, this);
+	public static final List<KeyBinding> keys = new ArrayList<>();
+	public static final List<Option<?>> options = new ArrayList<>();
+	public List<Option<?>> getAllOptions(){
+		return options;
 	}
 	
 	public KeyBinding getKey(int i) {
-		return keys[i];
+		return keys.get(i);
 	}
 
 	public String getKeyBindName(int id) {
@@ -420,13 +419,13 @@ public class GameSettings {
 		if(option == advancedOpenGL) mc.renderGlobal.loadRenderers();
 		if(option == biomeWater) {
 			mc.renderGlobal.loadRenderers();
-			mc.renderEngine.updateDynamicTextures();
+			mc.renderEngine.updateDynamicTextures(false);
 		}
 		if(option == treeShadows) mc.renderGlobal.loadRenderers();
 		if(option == placementMode && mc.thePlayer != null) mc.thePlayer.syncPlacementMode();
 		if(option == animations || option == customAnimations) {
 			mc.renderEngine.refreshTexturesAndDisplayErrors();
-			mc.renderEngine.updateDynamicTextures();
+			mc.renderEngine.updateDynamicTextures(false);
 		}
 		if(option == fullscreen || option == borderlessFullscreen) mc.gameWindow.updateWindowState();
 		if(option == guiScale) {
diff --git a/src/main/java/net/minecraft/client/option/KeyBinding.java b/src/main/java/net/minecraft/client/option/KeyBinding.java
index 1f91132fb..68184cee3 100644
--- a/src/main/java/net/minecraft/client/option/KeyBinding.java
+++ b/src/main/java/net/minecraft/client/option/KeyBinding.java
@@ -7,7 +7,6 @@ import net.minecraft.client.input.InputDevice;
 import net.minecraft.core.lang.I18n;
 
 public class KeyBinding {
-	
 	private static Map<Character, InputDevice> charToInputDeviceMap = new HashMap<>();
 	private static Map<InputDevice, Character> inputDeviceToCharMap = new HashMap<>();
 	
@@ -39,6 +38,7 @@ public class KeyBinding {
 		this.id = id;
 		this.inputDevice = null;
 		this.keyCode = -1;
+		GameSettings.keys.add(this);
 	}
 
 	public KeyBinding setDefault(InputDevice device, int keyCode) {
diff --git a/src/main/java/net/minecraft/client/option/Option.java b/src/main/java/net/minecraft/client/option/Option.java
index d05b7b1da..6b197e4b7 100644
--- a/src/main/java/net/minecraft/client/option/Option.java
+++ b/src/main/java/net/minecraft/client/option/Option.java
@@ -14,6 +14,7 @@ public abstract class Option<E> {
 		this.name = name;
 		this.value = defaultValue;
 		this.defaultValue = defaultValue;
+		GameSettings.options.add(this);
 	}
 
 	public void set(E value) {
diff --git a/src/main/java/net/minecraft/client/option/VolumeOption.java b/src/main/java/net/minecraft/client/option/VolumeOption.java
index c2e807161..4f0974e19 100644
--- a/src/main/java/net/minecraft/client/option/VolumeOption.java
+++ b/src/main/java/net/minecraft/client/option/VolumeOption.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.option;
 
 import net.minecraft.client.sound.SoundCategoryHelper;
-import net.minecraft.client.sound.SoundManager;
+import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.core.sound.SoundCategory;
 import paulscode.sound.SoundSystem;
 
@@ -16,10 +16,10 @@ public class VolumeOption extends FloatOption{
 	@Override
 	public void onUpdate() {
 		super.onUpdate();
-		gameSettings.mc.sndManager.onSoundOptionsChanged();
-		SoundSystem soundSystem = SoundManager.getSoundSystem();
+		gameSettings.mc.sndManager.updateOptions();
+		SoundSystem soundSystem = SoundEngine.getSoundSystem();
 		if (soundCategory != SoundCategory.GUI_SOUNDS && !soundSystem.playing("sound_audio_options")) {
-			gameSettings.mc.sndManager.playSound(soundCategory.changedSound, soundCategory, 1f, 1f, "sound_audio_options");
+			gameSettings.mc.sndManager.playSoundId(soundCategory.changedSound, soundCategory, 1f, 1f, "sound_audio_options");
 		} else if (soundCategory != SoundCategory.GUI_SOUNDS) {
 			soundSystem.setVolume("sound_audio_options", SoundCategoryHelper.getEffectiveVolume(soundCategory, gameSettings));
 		}
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 9c4ff7cbe..80d9856b1 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.Item;
@@ -143,7 +143,7 @@ public abstract class PlayerController {
 		return false;
 	}
 
-	public boolean destroyBlock(int x, int y, int z, Side side, EntityPlayer player) {
+	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
 		if (!player.getGamemode().canInteract()) return false;
 		setMineBlock(null, null, null);
 		World world = mc.theWorld;
@@ -217,7 +217,7 @@ public abstract class PlayerController {
 		return mc.thePlayer.getGamemode().getEntityReachDistance();
 	}
 
-	public boolean useItem(EntityPlayer player, World world, ItemStack stack) {
+	public boolean useItem(Player player, World world, ItemStack stack) {
 		if (!player.getGamemode().canInteract()) return false;
 		int prevStackSize = stack.stackSize;
 		ItemStack newItemStack = stack.useItemRightClick(world, player);
@@ -231,7 +231,7 @@ public abstract class PlayerController {
 		return false;
 	}
 
-	public void initPlayer(EntityPlayer player) {
+	public void initPlayer(Player player) {
 		player.yRot = -180F;
 	}
 
@@ -240,53 +240,53 @@ public abstract class PlayerController {
 		
 		syncCurrentPlayItem();
 		previousDamage = currentDamage;
-		mc.sndManager.playRandomMusicIfReady();
+		mc.sndManager.tick();
 	}
 
 	public boolean canHurtPlayer() {
 		return true;
 	}
 
-	public void adjustPlayer(EntityPlayer player) {
+	public void adjustPlayer(Player player) {
 	}
 
-	public boolean useItemOn(EntityPlayer entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+	public boolean useItemOn(Player player, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
 	{
-		if (!entityplayer.getGamemode().canInteract()) return false;
+		if (!player.getGamemode().canInteract()) return false;
 		int i1 = world.getBlockId(blockX, blockY, blockZ);
-		if (!entityplayer.isSneaking() || entityplayer.inventory.getCurrentItem() == null) {
-			if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, blockX, blockY, blockZ, entityplayer, side, xPlaced, yPlaced)) {
+		if (!player.isSneaking() || player.inventory.getCurrentItem() == null) {
+			if (i1 > 0 && Block.blocksList[i1].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
 				return true;
 			}
 		}
 		if (itemstack == null) {
 			return false;
 		} else {
-			return itemstack.useItem(entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+			return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 		}
 	}
 
-	public EntityPlayer createPlayer(World world) {
-		return new EntityPlayerSP(mc, world, mc.session, world.dimension.id);
+	public Player createPlayer(World world) {
+		return new LocalPlayer(mc, world, mc.session, world.dimension.id);
 	}
 
-	public boolean interact(EntityPlayer entityplayer, Entity entity) {
-		if (!entityplayer.getGamemode().canInteract()) return false;
-		return entityplayer.useCurrentItemOnEntity(entity);
+	public boolean interact(Player player, Entity entity) {
+		if (!player.getGamemode().canInteract()) return false;
+		return player.useCurrentItemOnEntity(entity);
 	}
 
-	public void attack(EntityPlayer entityplayer, Entity entity) {
-		if (!entityplayer.getGamemode().canInteract()) return;
-		entityplayer.attackTargetEntityWithCurrentItem(entity);
+	public void attack(Player player, Entity entity) {
+		if (!player.getGamemode().canInteract()) return;
+		player.attackTargetEntityWithCurrentItem(entity);
 	}
 
-	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, EntityPlayer entityplayer) {
-		return entityplayer.craftingInventory.clickInventorySlot(action, args, entityplayer);
+	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, Player player) {
+		return player.craftingInventory.clicked(action, args, player);
 	}
 
-	public void handleCloseInventory(int i, EntityPlayer entityplayer) {
-		entityplayer.craftingInventory.onCraftGuiClosed(entityplayer);
-		entityplayer.craftingInventory = entityplayer.inventorySlots;
+	public void handleCloseInventory(int i, Player player) {
+		player.craftingInventory.onCraftGuiClosed(player);
+		player.craftingInventory = player.inventorySlots;
 	}
 	
 	public void playDigSound(Block block, int x, int y, int z) {
@@ -304,7 +304,7 @@ public abstract class PlayerController {
 	
 	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {}
 
-	public void initLevel(World world) {}
+	public void initWorld(World world) {}
 
 	public void setPaintingType(ArtType art)
 	{
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 760aeae39..8e9290846 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
+import net.minecraft.client.net.handler.ClientPacketHandler;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.client.entity.player.EntityClientPlayerMP;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.client.net.handler.NetClientHandler;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -15,17 +15,17 @@ import net.minecraft.core.world.World;
 
 public class PlayerControllerMP extends PlayerController {
 
-	protected NetClientHandler netHandler;
+	protected ClientPacketHandler netHandler;
 	protected int currentItem;
 
-	public PlayerControllerMP(Minecraft minecraft, NetClientHandler netHandler) {
+	public PlayerControllerMP(Minecraft minecraft, ClientPacketHandler netHandler) {
 		super(minecraft);
 		
 		this.netHandler = netHandler;
 	}
 
 	@Override
-	public boolean destroyBlock(int x, int y, int z, Side side, EntityPlayer player) {
+	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
 		int id = mc.theWorld.getBlockId(x, y, z);
 		boolean removed = super.destroyBlock(x, y, z, side, player);
 		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
@@ -41,17 +41,17 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
 		super.hitBlock(x, y, z, side, xHit, yHit);
-		netHandler.addToSendQueue(new Packet14BlockDig(1, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(1, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new Packet14BlockDig(0, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(0, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
 	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new Packet14BlockDig(2, x, y, z, side, xHit, yHit));
+		netHandler.addToSendQueue(new PlayerActionPacket(2, x, y, z, side, xHit, yHit));
 	}
 	
 	@Override
@@ -59,55 +59,55 @@ public class PlayerControllerMP extends PlayerController {
 		int i = mc.thePlayer.inventory.currentItem;
 		if (i != currentItem) {
 			currentItem = i;
-			netHandler.addToSendQueue(new Packet16BlockItemSwitch(currentItem));
+			netHandler.addToSendQueue(new SetCarriedItemPacket(currentItem));
 		}
 	}
 
 	@Override
-	public boolean useItemOn(EntityPlayer entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+	public boolean useItemOn(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new Packet15Place(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced));
+		netHandler.addToSendQueue(new UseItemPacket(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced));
 		boolean flag = super.useItemOn(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
 		return flag;
 	}
 
 	@Override
-	public boolean useItem(EntityPlayer entityplayer, World world, ItemStack itemstack) {
+	public boolean useItem(Player entityplayer, World world, ItemStack itemstack) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new Packet15Place(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0));
+		netHandler.addToSendQueue(new UseItemPacket(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0));
 		boolean flag = super.useItem(entityplayer, world, itemstack);
 		return flag;
 	}
 
 	@Override
-	public EntityPlayer createPlayer(World world) {
-		return new EntityClientPlayerMP(mc, world, mc.session, netHandler);
+	public Player createPlayer(World world) {
+		return new MultiplayerLocalPlayer(mc, world, mc.session, netHandler);
 	}
 
 	@Override
-	public void attack(EntityPlayer entityplayer, Entity entity) {
+	public void attack(Player entityplayer, Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new Packet7UseEntity(entityplayer.id, entity.id, 1));
+		netHandler.addToSendQueue(new InteractPacket(entityplayer.id, entity.id, InteractPacket.ACTION_ATTACK));
 		entityplayer.attackTargetEntityWithCurrentItem(entity);
 	}
 
 	@Override
-	public boolean interact(EntityPlayer entityplayer, Entity entity) {
+	public boolean interact(Player entityplayer, Entity entity) {
 		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new Packet7UseEntity(entityplayer.id, entity.id, 0));
+		netHandler.addToSendQueue(new InteractPacket(entityplayer.id, entity.id, InteractPacket.ACTION_INTERACT));
 		return entityplayer.useCurrentItemOnEntity(entity);
 	}
 
 	@Override
-	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, EntityPlayer entityplayer) {
-		short actionId = entityplayer.craftingInventory.getActionId(entityplayer.inventory);
+	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, Player entityplayer) {
+		short actionId = entityplayer.craftingInventory.backup(entityplayer.inventory);
 		ItemStack itemstack = super.handleInventoryMouseClick(windowId, action, args, entityplayer);
-		netHandler.addToSendQueue(new Packet102WindowClick(windowId, action, args, itemstack, actionId));
+		netHandler.addToSendQueue(new ContainerClickPacket(windowId, action, args, itemstack, actionId));
 		return itemstack;
 	}
 
 	@Override
-	public void handleCloseInventory(int i, EntityPlayer entityplayer) {
+	public void handleCloseInventory(int i, Player entityplayer) {
 		if (i == -9999) {
         } else {
         }
@@ -116,6 +116,6 @@ public class PlayerControllerMP extends PlayerController {
 	@Override
 	public void setPaintingType(ArtType art)
 	{
-		netHandler.addToSendQueue(new Packet139SetPaintingMotive(art));
+		netHandler.addToSendQueue(new SetPaintingArtPacket(art));
 	}
 }
diff --git a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index e417cc58f..05e609360 100644
--- a/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -2,8 +2,8 @@ package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 
@@ -14,11 +14,11 @@ public class PlayerControllerSP extends PlayerController {
 	}
 
 	@Override
-	public boolean destroyBlock(int x, int y, int z, Side side, EntityPlayer player) {
+	public boolean destroyBlock(int x, int y, int z, Side side, Player player) {
 		if (!player.getGamemode().canInteract()) return false;
 		int id = mc.theWorld.getBlockId(x, y, z);
 		int meta = mc.theWorld.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = mc.theWorld.getBlockTileEntity(x, y, z);
+		BlockEntity blockEntity = mc.theWorld.getBlockEntity(x, y, z);
 		boolean removed = super.destroyBlock(x, y, z, side, player);
 		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
@@ -26,7 +26,7 @@ public class PlayerControllerSP extends PlayerController {
 			item.onDestroyBlock(mc.theWorld, id, x, y, z, side, mc.thePlayer);
 		}
 		if (removed && mc.thePlayer.getGamemode().dropBlockOnBreak()) {
-			Block.blocksList[id].harvestBlock(mc.theWorld, mc.thePlayer, x, y, z, meta, tileEntity);
+			Block.blocksList[id].harvestBlock(mc.theWorld, mc.thePlayer, x, y, z, meta, blockEntity);
 		}
 
 		if (item != null && item.stackSize <= 0)
diff --git a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
similarity index 62%
rename from src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
rename to src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
index 1a53d964b..a9785542e 100644
--- a/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/BlockEntityRenderDispatcher.java
@@ -4,46 +4,46 @@ import java.util.*;
 
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.client.render.tileentity.*;
+import net.minecraft.client.render.blockentity.*;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.entity.*;
-import net.minecraft.core.block.piston.TileEntityPistonMoving;
+import net.minecraft.core.block.piston.MovingPistonBlockEntity;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
-public class TileEntityRenderDispatcher
+public class BlockEntityRenderDispatcher
 {
 
-    private TileEntityRenderDispatcher()
+    private BlockEntityRenderDispatcher()
     {
         renderers = new HashMap<>();
-        renderers.put(TileEntitySign.class, new TileEntityRendererSign());
-        renderers.put(TileEntityFlag.class, new TileEntityRendererFlag());
-        renderers.put(TileEntityMobSpawner.class, new TileEntityRendererMobSpawner());
-        renderers.put(TileEntityPistonMoving.class, new TileEntityRendererPiston());
-        renderers.put(TileEntityFlowerJar.class, new TileEntityRendererFlowerJar());
-        renderers.put(TileEntityMeshGold.class, new TileEntityRendererMesh());
-
-        for (TileEntityRenderer<?> tileEntityRenderer : renderers.values())
+        renderers.put(SignBlockEntity.class, new SignBlockEntityRenderer());
+        renderers.put(FlagBlockEntity.class, new FlagBlockEntityRenderer());
+        renderers.put(MobSpawnerBlockEntity.class, new MobSpawnerBlockEntityRenderer());
+        renderers.put(MovingPistonBlockEntity.class, new PistonBlockEntityRenderer());
+        renderers.put(FlowerJarBlockEntity.class, new FlowerJarBlockEntityRenderer());
+        renderers.put(GoldMeshBlockEntity.class, new MeshBlockEntityRenderer());
+
+        for (BlockEntityRenderer<?> blockEntityRenderer : renderers.values())
         {
-            tileEntityRenderer.setRenderDispatcher(this);
+            blockEntityRenderer.setRenderDispatcher(this);
         }
 
     }
 
     @SuppressWarnings("unchecked") // trust me this is safe, Notch did it first
-    public <T extends TileEntity> TileEntityRenderer<T> getRenderer(Class<? extends TileEntity> e)
+    public <T extends BlockEntity> BlockEntityRenderer<T> getRenderer(Class<? extends BlockEntity> e)
     {
-        TileEntityRenderer<? extends TileEntity> r = renderers.get(e);
-        if(r == null && e != TileEntity.class)
+        BlockEntityRenderer<? extends BlockEntity> r = renderers.get(e);
+        if(r == null && e != BlockEntity.class)
         {
-            r = getRenderer((Class<? extends TileEntity>) e.getSuperclass());
+            r = getRenderer((Class<? extends BlockEntity>) e.getSuperclass());
             renderers.put(e, r);
         }
-        return (TileEntityRenderer<T>) r;
+        return (BlockEntityRenderer<T>) r;
     }
 
-    public <T extends TileEntity> TileEntityRenderer<T> getRenderer(T tileEntity)
+    public <T extends BlockEntity> BlockEntityRenderer<T> getRenderer(T tileEntity)
     {
         if(tileEntity == null)
         {
@@ -55,7 +55,7 @@ public class TileEntityRenderDispatcher
         }
     }
 
-    public <T extends TileEntity> boolean hasRenderer(T tileEntity)
+    public <T extends BlockEntity> boolean hasRenderer(T tileEntity)
     {
         return getRenderer(tileEntity) != null;
     }
@@ -76,7 +76,7 @@ public class TileEntityRenderDispatcher
         viewLerpPosZ = (float) camera.getZ(partialTick);
     }
 
-    public <T extends TileEntity> void renderTileEntity(Tessellator tessellator, T tileEntity, float partialTick)
+    public <T extends BlockEntity> void renderTileEntity(Tessellator tessellator, T tileEntity, float partialTick)
     {
         if(tileEntity.getDistanceFrom(viewLerpPosX, viewLerpPosY, viewLerpPosZ) < 4096D)
         {
@@ -97,9 +97,9 @@ public class TileEntityRenderDispatcher
         }
     }
 
-    public <T extends TileEntity> void renderTileEntity(Tessellator tessellator, T tileEntity, double x, double y, double z, float partialTick)
+    public <T extends BlockEntity> void renderTileEntity(Tessellator tessellator, T tileEntity, double x, double y, double z, float partialTick)
     {
-        TileEntityRenderer<T> renderer = getRenderer(tileEntity);
+        BlockEntityRenderer<T> renderer = getRenderer(tileEntity);
         if(renderer != null)
         {
             renderer.doRender(tessellator, tileEntity, x, y, z, partialTick);
@@ -109,7 +109,7 @@ public class TileEntityRenderDispatcher
     public void updateRendererWorldCache(World world)
     {
         worldObj = world;
-        for (TileEntityRenderer<?> renderer : renderers.values())
+        for (BlockEntityRenderer<?> renderer : renderers.values())
         {
             if (renderer != null)
             {
@@ -123,8 +123,8 @@ public class TileEntityRenderDispatcher
         return fontRenderer;
     }
 
-    private final Map<Class<?>, TileEntityRenderer<?>> renderers;
-    public static TileEntityRenderDispatcher instance = new TileEntityRenderDispatcher();
+    private final Map<Class<?>, BlockEntityRenderer<?>> renderers;
+    public static BlockEntityRenderDispatcher instance = new BlockEntityRenderDispatcher();
     private FontRenderer fontRenderer;
     public static double renderPosX;
     public static double renderPosY;
